      SUBROUTINE SF16R(X,BER,BEI,AKER,AKEI,IERR)
         INTEGER IERR
         REAL AKEI,AKER,BEI,BER,X
         EXTERNAL UTSF10
         INTEGER I
         REAL ARG,B1,B2,B3,B4,C1,C2,C3,C4,CON,DC,DCM,DE,DS,DSM,DSQ,E1,
     1        E2,HALF,ONE,R1,R2,S,SM,SYS001,SYS003,SYS005,SYS011,
     2        SYS029,SYS039,SYS059,T,TEN,TM,Z,Z4,ZERO,ZI,ZIM,ZMAX,ZSQ
         DIMENSION C1(9),C2(9),C3(9),C4(9),E1(9),E2(9)
         DATA TEN/10.E0/,ONE/1.E0/,ZERO/0.E0/,HALF/.5E0/,C1(1)
     1        /5.160705E-05/,   C1(2)/-4.898713E-03/,  C1(3)
     2        /.2597773E0/,    C1(4)/-7.242257E0/,   C1(5)
     3        /93.85967E0/,  C1(6)/-470.9503E0/,
     4        C1(7)/678.1684E0/,  C1(8)/-156.250E0/,
     5        C1(9)/1.0E0/,C2(1)/4.49130E-06/,C2(2)
     6        /-5.444243E-04/,   C2(3)/3.842883E-02/, C2(4)
     7        /-1.496334E0/,  C2(5)/28.96903E0/,
     8        C2(6)/-240.2808E0/,  C2(7)/678.1684E0/,
     9        C2(8)/-434.0278E0/
         DATA C2(9)/25.0E0/,C3(1)/1.543630E-05/,
     1        C3(2)/-1.806478E-03/,  C3(3)/.1222087E0/,
     2        C3(4)/-4.518746E0/,   C3(5)/81.95248E0/,
     3        C3(6)/-623.0137E0/,  C3(7)/1548.485E0/,
     4        C3(8)/-795.7176E0/,  C3(9)/25.0E0/,
     5        C4(1)/1.216111E-06/, C4(2)/-1.797628E-04/,  C4(3)
     6        /1.593801E-02/,  C4(4)/-.8061529E0/,  C4(5)
     7        /21.21235E0/,  C4(6)/-255.0972E0/,
     8        C4(7)/1153.828E0/,  C4(8)
     9        /-1412.851E0/,  C4(9)/234.375E0/
         DATA E1(1)/4.92E-08/,E1(2)/1.452E-07/,E1(3)/1.35E-08/,
     1        E1(4)/-1.6192E-06/,E1(5)/-1.12207E-05/,E1(6)
     2        /-5.17869E-05/,E1(7)/7.0E-10/,E1(8)/8.838835E-03/,
     3        E1(9)/1.0E0/,E2(1)/-2.43E-08/,E2(2)/7.5E-08/,E2(3)
     4        /5.929E-07/,E2(4)/1.6431E-06/,E2(5)/-7.2E-09/,E2(6)
     5        /-5.18006E-05/,E2(7)/-7.031241E-04/,E2(8)
     6        /-8.8388340E-03/,E2(9)/0.0E0/,SYS005
     7        /1.570796/,  SYS011/0.3926991/,
     8        SYS003/6.283185/,  SYS001/3.141593/,
     9        SYS039/0.5772157/
         DATA SYS029/0.7071068/,  SYS059/3.4E38/,  ZMAX/2.04E03/
       IERR = 0
       Z = ABS(X)
       IF (Z .GT. TEN) GO TO 30
          IF (Z .EQ. ZERO) GO TO 20
             Z = Z/TEN
             ZSQ = Z*Z
             Z4 = ZSQ*ZSQ
             B1 = C1(1)
             B2 = C2(1)
             B3 = C3(1)
             B4 = C4(1)
             DO 10 I = 2, 9
                B1 = B1*Z4 + C1(I)
                B2 = B2*Z4 + C2(I)
                B3 = B3*Z4 + C3(I)
                B4 = B4*Z4 + C4(I)
   10        CONTINUE
             BER = B1
             BEI = ZSQ*B2
             IF (X .LT. ZERO) GO TO 60
                R1 = ZSQ*B3
                R2 = Z4*B4
                CON = (ALOG(X*HALF) + SYS039)
                AKEI = -SYS005*HALF*BER + (R1 - BEI*CON)
                AKER = SYS005*HALF*BEI - (R2 + BER*CON)
                GO TO 90
   20     CONTINUE
          BER = ONE
          BEI = ZERO
          AKEI = -HALF*SYS005
          AKER = SYS059
          GO TO 90
   30  CONTINUE
       IF (Z .GT. ZMAX) GO TO 50
          ZI = TEN/Z
          ZIM = -ZI
          S = E1(1)
          SM = S
          T = E2(1)
          TM = T
          DO 40 I = 2, 9
             S = S*ZI + E1(I)
             T = T*ZI + E2(I)
             SM = SM*ZIM + E1(I)
             TM = TM*ZIM + E2(I)
   40     CONTINUE
          ARG = Z*SYS029
          DS = SIN(ARG-SYS011)
          DC = COS(ARG-SYS011)
          DSM = SIN(ARG+SYS011)
          DCM = COS(ARG+SYS011)
          DE = EXP(ARG)
          DSQ = SQRT(SYS003*Z)
          BER = DE*(S*DC - T*DS)/DSQ
          BEI = DE*(T*DC + S*DS)/DSQ
          IF (X .LT. ZERO) GO TO 60
             AKEI = SYS001*(TM*DCM - SM*DSM)/(DE*DSQ)
             AKER = SYS001*(SM*DCM + TM*DSM)/(DE*DSQ)
             GO TO 90
   50  CONTINUE
       BER = ZERO
       BEI = ZERO
       IERR = 66
       IF (X .LT. ZERO) GO TO 70
          AKEI = ZERO
          AKER = ZERO
          GO TO 80
   60  CONTINUE
       IERR = 1
   70  CONTINUE
       AKEI = SYS059
       AKER = SYS059
       IF (IERR .EQ. 0) GO TO 90
   80  CONTINUE
       CALL UTSF10(IERR,16)
   90  RETURN
      END
